﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.51
@EndOfDesignText@
' TIP: you make it yourself a lot easier if you LowerCase all the IDs!
Sub Process_Globals
	Dim BANano As BANano 'ignore
End Sub

public Sub AddRows(RowIDPrefix As String, Rows As Int, classes As String) As List
	RowIDPrefix = RowIDPrefix.ToLowerCase
	Dim l As List
	l.Initialize
	For i = 1 To Rows
		Dim myRow As GridRow
		myRow.Initialize(RowIDPrefix & i, classes)
		l.Add(myRow)
	Next
	Return l
End Sub

public Sub AddColumns(CellIDPrefix As String, theRow As GridRow, Cells As Int, classes As String)
	CellIDPrefix = CellIDPrefix.ToLowerCase
	For i = 1 To Cells
		Dim myCol As GridColumn
		myCol.Initialize(theRow.ID & CellIDPrefix & i, classes)
		theRow.cols.Add(myCol)
	Next
End Sub

public Sub BuildGrid(TargetID As String, Rows As List)
	TargetID = "#" & TargetID.ToLowerCase
	Dim s As StringBuilder
	s.Initialize
	s.Append($"<div class="container">"$)
	For i = 0 To Rows.Size - 1
		Dim myRow As GridRow = Rows.Get(i)
		s.Append($"<div id="${myRow.ID}" class="${myRow.Classes}">"$)
		For j = 0 To myRow.Cols.Size - 1
			Dim myCol As GridColumn = myRow.Cols.Get(j)
			s.Append($"<div id="${myCol.ID}" class="${myCol.Classes}"></div>"$)
		Next
		s.Append($"</div>"$)
	Next
	s.Append($"</div>"$)
	BANano.GetElement(TargetID).setHTML(s.toString)
End Sub

public Sub Content(TargetID As String, ID As String, Text As String)
	TargetID = "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	BANano.GetElement(TargetID).RenderAppend( $"<p id="${ID}">"$ & Text & "</p>","")
End Sub

public Sub Header(TargetID As String, ID As String, Level As Int, Text As String)
	TargetID =  "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	BANano.GetElement(TargetID).RenderAppend($"<h${Level} id="${ID}">${Text}</h${Level}>"$,"")
End Sub

Public Sub Button(TargetID As String, ID As String, Text As String, ColorVariant As String, EventHandler As Object, replaceMe As Boolean) ' beware replace is a reserver keyword!
	TargetID = "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	Dim tgt As BANanoElement = BANano.GetElement(TargetID)
	Dim btn() As BANanoElement
	If replaceMe Then		
		btn = tgt.Children("")
		btn(0).RenderReplace($"<button id="${ID}" class="${ColorVariant}">${Text}</button>"$,"")
		btn = tgt.Children("") ' an Umbrella thing, for some reason, we'll have to re-grab the buttons from the target to allow setting the events again
	Else
		btn = tgt.RenderAppend($"<button id="${ID}" class="${ColorVariant}">${Text}</button>"$,"").Children("")
	End If
	
	' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM!
	btn(0).HandleEvents("mousedown", EventHandler, ID & "_clicked")
End Sub

public Sub Image(TargetID As String, ID As String, Src As String, AltText As String)
	TargetID = "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	BANano.GetElement(TargetID).RenderAppend($"<img id="${ID}" src="${Src}" alt="${AltText}"/>"$, "")
End Sub

public Sub List(TargetID As String, ID As String, Ordered As Boolean, Items As List, EventHandler As Object)
	TargetID = "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	Dim s As StringBuilder
	s.Initialize
	If Ordered Then
		s.Append($"<ol id="${ID}">"$)
	Else
		s.Append($"<ul id="${ID}">"$)
	End If	
	For i = 0 To Items.Size - 1
		Dim item As String = Items.Get(i)
		s.Append($"<li id="${ID}_${(i+1)}" class="${ID}_event">${item}</li>"$)
	Next	
	If Ordered Then
		s.Append("</ol>")
	Else
		s.Append("</ul>")
	End If
	BANano.GetElement(TargetID).RenderAppend(s.ToString, "")
	' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM!
	' we only have to define it on our class (ID & "_event") once because we can retrieve wich one from the event later
	BANano.GetElement($".${ID}_event"$).HandleEvents("mousedown, touchstart", EventHandler, ID & "_clicked")
End Sub

public Sub Code(TargetID As String, ID As String, CodeText As String)
	TargetID = "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	BANano.GetElement(TargetID).RenderAppend( $"<pre id="${ID}">"$ & CodeText & "</pre>","")
End Sub

public Sub BlockQuote(TargetID As String, ID As String, Text As String, cite As String)
	TargetID = "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	BANano.GetElement(TargetID).RenderAppend( $"<blockquote id="${ID}" cite=${cite}>"$ & Text & "</blockquote>","")
End Sub

public Sub Card(TargetID As String, ID As String, Rows As List, Classes As String)
	TargetID = "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	BANano.GetElement(TargetID).RenderAppend($"<div id="${ID}" class="${Classes}"></div>"$, "")
	BuildGrid(ID, Rows)
End Sub

public Sub LoginForm(TargetID As String, ID As String, eventHandler As Object)
	TargetID = "#" & TargetID.ToLowerCase
	ID = ID.ToLowerCase
	Dim template As String = $"<input id="${ID}" type="checkbox"/ class="modal">
     <div class="modal">
	 <div class="card large">
	 <label for="${ID}" class="modal-close"></label>
	      <legend>Login form</legend>
            <div class="input-group fluid">
              <label For="username" style="width: 80px;">Username</label>
              <input Type="text" value="" id="${ID}username" placeholder="username">
            </div>
            <div class="input-group fluid">
              <label For="password" style="width: 80px;">Password</label>
              <input Type="password" value="" id="${ID}password" placeholder="password">
            </div>
            <div class="input-group fluid">
              <button id="${ID}btnlogin" class="primary">Login</button>
              <button id="${ID}btnforgot">Forgot password?</button>
            </div>
      </div>
	  </div>"$
	
	BANano.GetElement(TargetID).RenderAppend(template, "")
	
	Dim btnLogin As BANanoElement = BANano.GetElement("#" & ID & "btnlogin")
	btnLogin.on("mousedown", eventHandler, ID & "btnlogin_clicked")
	Dim btnForgot As BANanoElement = BANano.GetElement("#" & ID & "btnforgot")
	btnForgot.on("mousedown", eventHandler, ID & "btnforgot_clicked")
End Sub