﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
Sub Class_Globals
	Private BANano As BANano 'ignore
	
	Public SharedVar As String = "SharedVar from class"
	
	Private lblTimer As Timer	
	Private lblTimeTimer As Timer
	Dim myString As String
	
	Dim ToKM As Double = 1.609344
	Dim ToMiles As Double = 0.8684
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(param As String)
	Log(param)
	Log(Shared.sharedVar)
End Sub

public Sub RunMe(Name As String)
	Dim myName As String = "Alain"
 
	' smartstrings (does not support date, time or xml functions)
	myString = $"Hello planet "B4X"! This is a test
    from ${myName} and ${Name}"$
	
	Log(myString)
 
	Log("myString.Contains('planet'): " & myString.Contains("planet"))
	
	Log(myString.SubString2(0,5) & Max(1,2) & " after")
	
	Dim myDate As String = DateTime.Date(DateTime.Now)
	Dim myTime As String = DateTime.Time(DateTime.Now)
	
	Dim myString As String = $"Here is the current date: ${myDate} and the current time: ${myTime}"$
	
	Log(myString)
	
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("0123456789").Append(CRLF).Append("0123456789")
	Log("sb.ToString: " & sb.ToString)
	Log("Length: " & sb.Length)  ' should show 21, including the return
	sb.Insert(2,"X")
	Log("sb.ToString: " & sb.ToString)
	sb.Remove(2,3)
	Log("sb.ToString: " & sb.ToString)
	
	Log(BANano.RunInlineJavascriptMethod("evaluate", Array As String("10 * 20")))
	
	TestJson
	
	BANano.CheckInternetConnection("ForAjaxCall")
		
	lblTimer.Initialize("lblTimer", 5000)
	lblTimer.Enabled = True
	
	lblTimeTimer.Initialize("lblTimeTimer", 1000)
	lblTimeTimer.Enabled = True
End Sub

Sub BANAno_IsConnectedResult(Tag As String, Result As Boolean)
	Log("Internet for: " & Tag & " = " & Result)
	Select Case Tag
		Case "ForAjaxCall"
			If Result Then
				Dim headers As Map
				headers.Initialize
				headers.put("Content-Type", "application/json")
				BANano.CallAjax("https://reqres.in/api/users?page=2","GET","jsonp", "","ID0001", False, headers)
			Else
				MiniCSS.Content("#r4c1", "contajax", "Cannot make Ajax call because you are not connected to the internet, but here is the last result:<br>" & Shared.Ajaxresult)
			End If
	End Select
End Sub

Sub BANano_CallAjaxResult(Success As Boolean, UniqueID As String, Result As String)
	Log(Success)
	Log(UniqueID)
	Log(Result)
	Shared.Ajaxresult = Result
	MiniCSS.Content("#r4c1", "contajax", Result)
End Sub

Sub lblTimer_Tick
	Log("Distance Ypres to Brugge: " & CalcDistance("K"))
	lblTimer.Enabled = False 
End Sub

Sub lblTimeTimer_Tick	
	Dim myTime As String = DateTime.Time(DateTime.Now)
	BANano.GetElement("#r1c2").Render($"Current time: {{time}}"$, $"{"time": "${myTime}"}"$)
End Sub

public Sub CalcDistance(Unit As String) As String
	Dim theta As Double
	Dim Distance As Double = 5
	
	Log(Max(Min(10,15), Min(20,30)))
		
	Dim Lat1, Lat2, Lon1, Lon2 As Double
	Lat1 = 50.85
	Lat2 = 2.8833
	Lon1 = 51.2098
	Lon2 = 3.225
	
	theta = Lon1 - Lon2
	Distance = Sin(deg2rad(Lat1)) * Sin(deg2rad(Lat2)) + Cos(deg2rad(Lat1)) * Cos(deg2rad(Lat2)) * Cos(deg2rad(theta))
	' logging some intermediate value
	Log("Distance = " & Distance)
	Distance = ACos(Distance)
	Distance = rad2deg(Distance)
	' logging some intermediate value
	Log("Distance = " & Distance)
	Distance = Distance * 60 * 1.1515
	
	Select Case Unit.ToUpperCase
		Case "K", "Z"
			Return "The distance is " & (Distance * ToKM) & " kilometers!"
		Case "N"
			Return "The distance is " & (Distance * ToMiles) & " miles!"
		Case Else
			Return "No idea what you are doing :-)"
	End Select
	
End Sub

' some helper methods
Sub deg2rad(Deg As Double) As Double
	Return Deg * cPI / 180
End Sub

Sub rad2deg(Rad As Double) As Double
	Return Rad * 180 / cPI
End Sub

public Sub TestJson()
	' String -> JSON
	Dim JSON As BANanoJSONParser
	JSON.Initialize($"{"menu": {
  "id": "file",
  "value": "File",
  "popup": {
    "menuitem": [
      {"value": "New", "onclick": "CreateNewDoc()"},
      {"value": "Open", "onclick": "OpenDoc()"},
      {"value": "Close", "onclick": "CloseDoc()"}
    ]
  }
}}"$)

	' exploring the JSON tree
	Dim Map1 As Map
	Map1 = JSON.NextObject
	Dim m As Map 'helper map for navigating
	Dim MenuItems As List
	m = Map1.Get("menu")
	m = m.Get("popup")
	MenuItems = m.Get("menuitem")
	For i = 0 To MenuItems.Size - 1
		m = MenuItems.Get(i)
		Log(m.Get("value"))
	Next
	
	' manipulating and generating a new JSON file
	Dim Data As List
	Data.Initialize
	Data.Add(1)
	Data.Add(2)
	Data.Add(3)
	Data.addAllAt(5,Array As String("1","2","3"))
	Data.Add(Map1) 'add the previous map loaded
	Dim JSONGenerator As BANanoJSONGenerator
	JSONGenerator.Initialize2(Data)

	Log(JSONGenerator.ToPrettyString(2))
	
	' different ways of adding to the local storage
	BANano.SetLocalStorage("myjson1", JSONGenerator)
	Log(BANano.GetLocalStorage("myjson1"))
	BANano.RemoveLocalStorage("myjson1")
	
	BANano.SetLocalStorage("myjson2", $"{"value": "test 1"}"$)	
	Log(BANano.GetLocalStorage("myjson2"))	
	BANano.RemoveLocalStorage("myjson2")
	
	BANano.SetLocalStorage("myjson3", "test 2")
	Log(BANano.GetLocalStorage("myjson3"))
	BANano.RemoveLocalStorage("myjson3")
End Sub